#include "stdafx.h"
#include "atlbase.h"
#include "Antidote APIOle VCpp MFC.h"
#include "MainFrm.h"
#include "Constantes.h"

#include "ChildFrm.h"
#include "Antidote APIOle VCpp MFCDoc.h"
#include "Antidote APIOle VCpp MFCView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


BEGIN_MESSAGE_MAP(CAntidoteAPIOleVCppMFCApp, CWinApp)
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
END_MESSAGE_MAP()

CAntidoteAPIOleVCppMFCApp::CAntidoteAPIOleVCppMFCApp()
{
}

CAntidoteAPIOleVCppMFCApp theApp;

static const CLSID clsid =
{ 0xA5274ACE, 0x9FA7, 0x40A1, { 0xAD, 0x93, 0xB0, 0x35, 0xD9, 0x84, 0x93, 0x5E } };
const GUID CDECL BASED_CODE _tlid =
		{ 0x644DC9A4, 0x28E, 0x4AC8, { 0xBD, 0x22, 0xBE, 0x3F, 0x9B, 0x67, 0x58, 0x71 } };
const WORD _wVerMajor = 1;
const WORD _wVerMinor = 0;

BOOL CAntidoteAPIOleVCppMFCApp::InitInstance()
{
	InitCommonControls();

	CWinApp::InitInstance();

	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}
	AfxEnableControlContainer();


	SetRegistryKey(_T("Druide informatique inc."));
	LoadStdProfileSettings(4);

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(IDR_MAINFRAME,
		RUNTIME_CLASS(CAntidoteAPIOleVCppMFCDoc),
		RUNTIME_CLASS(CChildFrame),
		RUNTIME_CLASS(CAntidoteAPIOleVCppMFCView));
	if (!pDocTemplate)
		return FALSE;
	AddDocTemplate(pDocTemplate);

	m_server.ConnectTemplate(clsid, pDocTemplate, FALSE);

	COleTemplateServer::RegisterAll();

	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame || !pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	if(cmdInfo.m_bRunEmbedded || cmdInfo.m_bRunAutomated)
	{
		return TRUE;
	}
	else if(cmdInfo.m_nShellCommand == CCommandLineInfo::AppUnregister)
	{
		m_server.UpdateRegistry(OAT_DISPATCH_OBJECT, NULL, NULL, FALSE);
		AfxOleUnregisterTypeLib(_tlid, _wVerMajor, _wVerMinor);
	}
	else
	{
		m_server.UpdateRegistry(OAT_DISPATCH_OBJECT);
		COleObjectFactory::UpdateRegistryAll();
		AfxOleRegisterTypeLib(AfxGetInstanceHandle(), _tlid);
	}

	if(!ProcessShellCommand(cmdInfo))
		return FALSE;

	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	return TRUE;
}


