#include "stdafx.h"
#include "Antidote APIOle VCpp MFC.h"

#include "Antidote APIOle VCpp MFCDoc.h"
#include "CntrItem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNCREATE(CAntidoteAPIOleVCppMFCDoc, CRichEditDoc)

BEGIN_MESSAGE_MAP(CAntidoteAPIOleVCppMFCDoc, CRichEditDoc)
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_LINKS, CRichEditDoc::OnUpdateEditLinksMenu)
	ON_COMMAND(ID_OLE_EDIT_LINKS, CRichEditDoc::OnEditLinks)
	ON_UPDATE_COMMAND_UI_RANGE(ID_OLE_VERB_FIRST, ID_OLE_VERB_LAST, CRichEditDoc::OnUpdateObjectVerbMenu)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CAntidoteAPIOleVCppMFCDoc, CRichEditDoc)
END_DISPATCH_MAP()

static const IID IID_IAntidoteAPIOleVCppMFC =
{ 0xAE5A776F, 0x2AF3, 0x4534, { 0x9E, 0x13, 0x8D, 0x72, 0x53, 0xA4, 0xD0, 0xB } };

BEGIN_INTERFACE_MAP(CAntidoteAPIOleVCppMFCDoc, CRichEditDoc)
	INTERFACE_PART(CAntidoteAPIOleVCppMFCDoc, IID_IAntidoteAPIOleVCppMFC, Dispatch)
END_INTERFACE_MAP()


CAntidoteAPIOleVCppMFCDoc::CAntidoteAPIOleVCppMFCDoc()
{
	EnableAutomation();

	AfxOleLockApp();
}

CAntidoteAPIOleVCppMFCDoc::~CAntidoteAPIOleVCppMFCDoc()
{
	AfxOleUnlockApp();
}

BOOL CAntidoteAPIOleVCppMFCDoc::OnNewDocument()
{
	if (!CRichEditDoc::OnNewDocument())
		return FALSE;

	SetModifiedFlag(FALSE);
	return TRUE;
}

BOOL CAntidoteAPIOleVCppMFCDoc::OnOpenDocument(LPCTSTR lpszPathName)
{
	if (!CRichEditDoc::OnOpenDocument(lpszPathName))
		return FALSE;

	SetModifiedFlag(FALSE);
	return TRUE;
}

CRichEditCntrItem* CAntidoteAPIOleVCppMFCDoc::CreateClientItem(REOBJECT* preo) const
{
	return new CAntidoteAPIOleVCppMFCCntrItem(preo, const_cast<CAntidoteAPIOleVCppMFCDoc*>(this));
}

#ifdef _DEBUG
void CAntidoteAPIOleVCppMFCDoc::AssertValid() const
{
	CRichEditDoc::AssertValid();
}

void CAntidoteAPIOleVCppMFCDoc::Dump(CDumpContext& dc) const
{
	CRichEditDoc::Dump(dc);
}
#endif //_DEBUG
