#include "stdafx.h"
#include "Antidote APIOle VCpp MFC.h"

#include "Antidote APIOle VCpp MFCDoc.h"
#include "CntrItem.h"
#include "Antidote APIOle VCpp MFCView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNCREATE(CAntidoteAPIOleVCppMFCView, CRichEditView)

BEGIN_MESSAGE_MAP(CAntidoteAPIOleVCppMFCView, CRichEditView)
	ON_WM_DESTROY()
END_MESSAGE_MAP()

CAntidoteAPIOleVCppMFCView::CAntidoteAPIOleVCppMFCView()
{
}

CAntidoteAPIOleVCppMFCView::~CAntidoteAPIOleVCppMFCView()
{
}

BOOL CAntidoteAPIOleVCppMFCView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CRichEditView::PreCreateWindow(cs);
}

void CAntidoteAPIOleVCppMFCView::OnInitialUpdate()
{
	CRichEditView::OnInitialUpdate();
}

void CAntidoteAPIOleVCppMFCView::OnDestroy()
{
   COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
   if (pActiveItem != NULL && pActiveItem->GetActiveView() == this)
   {
      pActiveItem->Deactivate();
      ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
   }
   CRichEditView::OnDestroy();
}


#ifdef _DEBUG
void CAntidoteAPIOleVCppMFCView::AssertValid() const
{
	CRichEditView::AssertValid();
}

void CAntidoteAPIOleVCppMFCView::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}

CAntidoteAPIOleVCppMFCDoc* CAntidoteAPIOleVCppMFCView::GetDocument() const
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAntidoteAPIOleVCppMFCDoc)));
	return (CAntidoteAPIOleVCppMFCDoc*)m_pDocument;
}
#endif //_DEBUG
