#pragma once

class CChildFrame;

class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
	CString maLangue;
	CString maVersionAPI;
public:
	CMainFrame();

public:

public:

public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	void						ActiveApplication							();
	void						ActiveDocument								(long idDocument);
	long						DonneDebutSelection						(long idDocument, long idZoneDeTexte);
	long 						DonneFinSelection							(long idDocument, long idZoneDeTexte);
	long 						DonneIdDocumentCourant				();
	long  					DonneIdZoneDeTexte						(long idDocument, long indiceZoneDeTexte);
	long  					DonneIdZoneDeTexteCourante		(long idDocument);
	void  					DonneIntervalle								(long idDocument, long idZoneDeTexte, long leDebut, long laFin, CString &strIntervalle);
	long  					DonneLongueurZoneDeTexte			(long idDocument, long idZoneDeTexte);
	long  					DonneNbZonesDeTexte						(long idDocument);
	void  					DonnePolice										(long idDocument, long idZoneDeTexte, CString &strNomPolice);
	void						DonneTitreDocCourant					(CString &strTitreDoc);
	void  					RemplaceIntervalle						(long idDocument, long idZoneDeTexte, long leDebut, long laFin, BSTR* laChaine);
	void  					SelectionneIntervalle					(long idDocument, long idZoneDeTexte, long leDebut, long laFin);

protected:  
	CToolBar				m_wndToolBar;

	void						AvertisAntidoteAppQuitte			();
	void						LanceCorrecteur								();
	void						LanceDictionnaires						();
	void						LanceDictionnaire							(const TCHAR* const);
	void						LanceGuides										();
	void						LanceGuide										(const TCHAR* const);

protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnClose();
	afx_msg void OnLangue();
	afx_msg void OnOutilsCorrecteur();
	afx_msg void OnOutilsDictionnaires();
	afx_msg void OnOutilsGuides();
};

extern CMainFrame* gMainFrame;
