#include "stdafx.h"
#include "Antidote APIOle VCpp MFC.h"
#include "ServeurClient.h"
#include "MainFrm.h"

ServeurClient gServeurClient; 

// ServeurClient

IMPLEMENT_DYNCREATE(ServeurClient, CCmdTarget)
ServeurClient::ServeurClient()
{
	EnableAutomation();
}

ServeurClient::~ServeurClient()
{
}

void ServeurClient::OnFinalRelease()
{
	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(ServeurClient, CCmdTarget)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(ServeurClient, CCmdTarget)
	DISP_FUNCTION_ID(ServeurClient, "ActiveApplication", dispidActiveApplication, ActiveApplication, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION_ID(ServeurClient, "ActiveDocument", dispidActiveDocument, ActiveDocument, VT_EMPTY, VTS_I4)
	DISP_FUNCTION_ID(ServeurClient, "DonneDebutSelection", dispidDonneDebutSelection, DonneDebutSelection, VT_I4, VTS_I4 VTS_I4)
	DISP_FUNCTION_ID(ServeurClient, "DonneFinSelection", dispidDonneFinSelection, DonneFinSelection, VT_I4, VTS_I4 VTS_I4)
	DISP_FUNCTION_ID(ServeurClient, "DonneIdDocumentCourant", dispidDonneIdDocumentCourant, DonneIdDocumentCourant, VT_I4, VTS_NONE)
	DISP_FUNCTION_ID(ServeurClient, "DonneIdZoneDeTexte", dispidDonneIdZoneDeTexte, DonneIdZoneDeTexte, VT_I4, VTS_I4 VTS_I4)
	DISP_FUNCTION_ID(ServeurClient, "DonneIdZoneDeTexteCourante", dispidDonneIdZoneDeTexteCourante, DonneIdZoneDeTexteCourante, VT_I4, VTS_I4)
	DISP_FUNCTION_ID(ServeurClient, "DonneIntervalle", dispidDonneIntervalle, DonneIntervalle, VT_BSTR, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION_ID(ServeurClient, "DonneLongueurZoneDeTexte", dispidDonneLongueurZoneDeTexte, DonneLongueurZoneDeTexte, VT_I4, VTS_I4 VTS_I4)
	DISP_FUNCTION_ID(ServeurClient, "DonneNbZonesDeTexte", dispidDonneNbZonesDeTexte, DonneNbZonesDeTexte, VT_I4, VTS_I4)
	DISP_FUNCTION_ID(ServeurClient, "DonnePolice", dispidDonnePolice, DonnePolice, VT_BSTR, VTS_I4 VTS_I4)
	DISP_FUNCTION_ID(ServeurClient, "DonneTitreDocCourant", dispidDonneTitreDocCourant, DonneTitreDocCourant, VT_BSTR, VTS_NONE)
	DISP_FUNCTION_ID(ServeurClient, "RemplaceIntervalle", dispidRemplaceIntervalle, RemplaceIntervalle, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_PBSTR)
	DISP_FUNCTION_ID(ServeurClient, "SelectionneIntervalle", dispidSelectionneIntervalle, SelectionneIntervalle, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
END_DISPATCH_MAP()

// {089BBAFD-0046-4276-909B-F4251CE600F8}
static const IID IID_IServeurClient =
{ 0x89BBAFD, 0x46, 0x4276, { 0x90, 0x9B, 0xF4, 0x25, 0x1C, 0xE6, 0x0, 0xF8 } };

BEGIN_INTERFACE_MAP(ServeurClient, CCmdTarget)
	INTERFACE_PART(ServeurClient, IID_IServeurClient, Dispatch)
END_INTERFACE_MAP()

// {213E0E51-BDD1-452B-82DE-C12B8F6E12AE}
IMPLEMENT_OLECREATE_FLAGS(ServeurClient, "AntidoteAPIOleVCppMFC.ServeurClient", afxRegApartmentThreading, 0x213e0e51, 0xbdd1, 0x452b, 0x82, 0xde, 0xc1, 0x2b, 0x8f, 0x6e, 0x12, 0xae)

// ----------------------------------------------------------------------------
// ActiveApplication
// ----------------------------------------------------------------------------
void ServeurClient::ActiveApplication(void)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());

	gMainFrame->ActiveApplication();
}

// ----------------------------------------------------------------------------
// ActiveDocument
// ----------------------------------------------------------------------------
void ServeurClient::ActiveDocument(LONG idDocument)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());

	gMainFrame->ActiveDocument(idDocument);
}

// ----------------------------------------------------------------------------
// DonneDebutSelection
// ----------------------------------------------------------------------------
LONG ServeurClient::DonneDebutSelection(LONG idDocument, LONG idZoneDeTexte)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());

	return gMainFrame->DonneDebutSelection(idDocument, idZoneDeTexte);
}

// ----------------------------------------------------------------------------
// DonneFinSelection
// ----------------------------------------------------------------------------
LONG ServeurClient::DonneFinSelection(LONG idDocument, LONG idZoneDeTexte)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());

	return gMainFrame->DonneFinSelection(idDocument, idZoneDeTexte);
}

// ----------------------------------------------------------------------------
// DonneIdDocumentCourant
// ----------------------------------------------------------------------------
LONG ServeurClient::DonneIdDocumentCourant(void)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());

	return gMainFrame->DonneIdDocumentCourant();
}

// ----------------------------------------------------------------------------
// DonneIdZoneDeTexte
// ----------------------------------------------------------------------------
LONG ServeurClient::DonneIdZoneDeTexte(LONG idDocument, LONG indiceZoneDeTexte)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());

	return gMainFrame->DonneIdZoneDeTexte(idDocument, indiceZoneDeTexte);
}

// ----------------------------------------------------------------------------
// DonneIdZoneDeTexteCourante
// ----------------------------------------------------------------------------
LONG ServeurClient::DonneIdZoneDeTexteCourante(LONG idDocument)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());

	return gMainFrame->DonneIdZoneDeTexteCourante(idDocument);
}

// ----------------------------------------------------------------------------
// DonneIntervalle
// ----------------------------------------------------------------------------
BSTR ServeurClient::DonneIntervalle(LONG idDocument, LONG idZoneDeTexte, LONG leDebut, LONG laFin)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());

	CString strResult;
	gMainFrame->DonneIntervalle(idDocument, idZoneDeTexte, leDebut, laFin, strResult);
	return strResult.AllocSysString();
}

// ----------------------------------------------------------------------------
// DonneLongueurZoneDeTexte
// ----------------------------------------------------------------------------
LONG ServeurClient::DonneLongueurZoneDeTexte(LONG idDocument, LONG idZoneDeTexte)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());

	return gMainFrame->DonneLongueurZoneDeTexte(idDocument, idZoneDeTexte);
}

// ----------------------------------------------------------------------------
// DonneNbZonesDeTexte
// ----------------------------------------------------------------------------
LONG ServeurClient::DonneNbZonesDeTexte(LONG idDocument)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());
	
	return gMainFrame->DonneNbZonesDeTexte(idDocument);
}

// ----------------------------------------------------------------------------
// DonnePolice
// ----------------------------------------------------------------------------
BSTR ServeurClient::DonnePolice(LONG idDocument, LONG idZoneDeTexte)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());

	CString strResult;
	gMainFrame->DonnePolice(idDocument, idZoneDeTexte, strResult);
	return strResult.AllocSysString();
}

// ----------------------------------------------------------------------------
// DonneTitreDocCourant
// ----------------------------------------------------------------------------
BSTR  ServeurClient::DonneTitreDocCourant()
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());

	CString strResult;
	gMainFrame->DonneTitreDocCourant(strResult);
	return strResult.AllocSysString();
}

// ----------------------------------------------------------------------------
// RemplaceIntervalle
// ----------------------------------------------------------------------------
void ServeurClient::RemplaceIntervalle(LONG idDocument, LONG idZoneDeTexte, LONG leDebut, LONG laFin, BSTR* laChaine)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());

	gMainFrame->RemplaceIntervalle(idDocument, idZoneDeTexte, leDebut, laFin, laChaine);
}

// ----------------------------------------------------------------------------
// SelectionneIntervalle
// ----------------------------------------------------------------------------
void ServeurClient::SelectionneIntervalle(LONG idDocument, LONG idZoneDeTexte, LONG leDebut, LONG laFin)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());

	gMainFrame->SelectionneIntervalle(idDocument, idZoneDeTexte, leDebut, laFin);
}
