#pragma once

class ServeurClient;
extern ServeurClient gServeurClient;

class ServeurClient : public CCmdTarget
{
	DECLARE_DYNCREATE(ServeurClient)

public:
	ServeurClient();
	virtual ~ServeurClient();

	virtual void OnFinalRelease();

protected:
	DECLARE_MESSAGE_MAP()
	DECLARE_OLECREATE(ServeurClient)
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()
	void ActiveApplication(void);

	enum 
	{
		dispidApiClient2 = 15L, dispidSelectionneIntervalle = 14L, dispidRemplaceIntervalle = 13L, dispidDonneTitreDocCourant = 12L, dispidDonnePolice = 11L, dispidDonneNbZonesDeTexte = 10L, dispidDonneLongueurZoneDeTexte = 9L, dispidDonneIntervalle = 8L, dispidDonneIdZoneDeTexteCourante = 7L, dispidDonneIdZoneDeTexte = 6L, dispidDonneIdDocumentCourant = 5L, dispidDonneFinSelection = 4L, dispidDonneDebutSelection = 3L, dispidActiveDocument = 2L, dispidActiveApplication = 1L
	};
	void ActiveDocument(LONG idDocument);
	LONG DonneDebutSelection(LONG idDocument, LONG idZoneDeTexte);
	LONG DonneFinSelection(LONG idDocument, LONG idZoneDeTexte);
	LONG DonneIdDocumentCourant(void);
	LONG DonneIdZoneDeTexte(LONG idDocument, LONG indiceZoneDeTexte);
	LONG DonneIdZoneDeTexteCourante(LONG idDocument);
	BSTR DonneIntervalle(LONG idDocument, LONG idZoneDeTexte, LONG leDebut, LONG laFin);
	LONG DonneLongueurZoneDeTexte(LONG idDocument, LONG idZoneDeTexte);
	LONG DonneNbZonesDeTexte(LONG idDocument);
	BSTR DonnePolice(LONG idDocument, LONG idZoneDeTexte);
	BSTR DonneTitreDocCourant();
	void RemplaceIntervalle(LONG idDocument, LONG idZoneDeTexte, LONG leDebut, LONG laFin, BSTR* laChaine);
	void SelectionneIntervalle(LONG idDocument, LONG idZoneDeTexte, LONG leDebut, LONG laFin);
};


