﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Threading;
using System.Globalization;

namespace Antidote_APIOle_VCSharp_dotNet
{

	static class Program
	{
		static String culture = "";

		[STAThread]
		static void Main()
		{
			CultureInfo originalCulture = new CultureInfo("fr-CA");
			Thread.CurrentThread.CurrentCulture = originalCulture;
			Thread.CurrentThread.CurrentUICulture = originalCulture;
			
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);
			Application.Run(frmMDIMain.Instance());
		}

		public static String DonneChaine(String valeurDemande)
		{
			if (culture == "")
			{
				CultureInfo originalCulture = Thread.CurrentThread.CurrentCulture;
				if (originalCulture.TwoLetterISOLanguageName.ToLower().CompareTo("fr") == 0)
						culture = "fr";
					else
						culture = "en";
			}
			if (culture == "en")
			{
				return Antidote_APIOle_VCSharp_dotNet.Properties.Chaines_en.ResourceManager.GetString(valeurDemande);
			}
			else
			{
				return Antidote_APIOle_VCSharp_dotNet.Properties.Chaines_fr.ResourceManager.GetString(valeurDemande);
			}
		}
	}
}
